#! /bin/sh

JYTHON=jython

run_test() {
    echo "Filenames: $@"
    ./doit.py --jython="$JYTHON" "$@"
}


test_failure() {
    run_test "$@" && echo '########## UNEXPECTED SUCCESS! ##########'
    echo
}

test_success() {
    run_test "$@" || echo '########## UNEXPECTED FAILURE! ##########'
    echo
}

echo "I expect this to work, but it doesn't:"
test_failure a/b/Foo.java a/__init__.py a/b/__init__.py a/b/Bar.py

echo "The addition of a/Foobar.java works around the problem:"
test_success a/b/Foo.java a/__init__.py a/b/__init__.py a/b/Bar.py a/Foobar.java

echo "Adding a Python file to the empty directory doesn't help:"
test_failure a/b/Foo.java a/__init__.py a/b/__init__.py a/b/Bar.py a/Foobar.py

echo "Surprisingly, breaking the Python imports (by removing one or more"
echo "__init__.py files) fixes the Java import:"
test_failure a/b/Foo.java a/__init__.py                 a/b/Bar.py
test_failure a/b/Foo.java               a/b/__init__.py a/b/Bar.py
test_failure a/b/Foo.java                               a/b/Bar.py

echo "And if there are no Python files at all, a.b.Foo can be imported:"
test_success a/b/Foo.java

